package edu.ndsu.cs.hayden.christensonAssignment3.cayenne.persistent.auto;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.List;

import org.apache.cayenne.BaseDataObject;
import org.apache.cayenne.exp.Property;

import edu.ndsu.cs.hayden.christensonAssignment3.cayenne.persistent.Student;

/**
 * Class _Course was generated by Cayenne.
 * It is probably a good idea to avoid changing this class manually,
 * since it may be overwritten next time code is regenerated.
 * If you need to make any customizations, please use subclass.
 */
public abstract class _Course extends BaseDataObject {

    private static final long serialVersionUID = 1L; 

    public static final String PK_PK_COLUMN = "PK";

    public static final Property<Integer> CAPACITY = Property.create("capacity", Integer.class);
    public static final Property<String> INSTRUCTOR = Property.create("instructor", String.class);
    public static final Property<String> NAME = Property.create("name", String.class);
    public static final Property<List<Student>> STUDENTS = Property.create("students", List.class);

    protected Integer capacity;
    protected String instructor;
    protected String name;

    protected Object students;

    public void setCapacity(int capacity) {
        beforePropertyWrite("capacity", this.capacity, capacity);
        this.capacity = capacity;
    }

    public int getCapacity() {
        beforePropertyRead("capacity");
        if(this.capacity == null) {
            return 0;
        }
        return this.capacity;
    }

    public void setInstructor(String instructor) {
        beforePropertyWrite("instructor", this.instructor, instructor);
        this.instructor = instructor;
    }

    public String getInstructor() {
        beforePropertyRead("instructor");
        return this.instructor;
    }

    public void setName(String name) {
        beforePropertyWrite("name", this.name, name);
        this.name = name;
    }

    public String getName() {
        beforePropertyRead("name");
        return this.name;
    }

    public void addToStudents(Student obj) {
        addToManyTarget("students", obj, true);
    }

    public void removeFromStudents(Student obj) {
        removeToManyTarget("students", obj, true);
    }

    @SuppressWarnings("unchecked")
    public List<Student> getStudents() {
        return (List<Student>)readProperty("students");
    }

    @Override
    public Object readPropertyDirectly(String propName) {
        if(propName == null) {
            throw new IllegalArgumentException();
        }

        switch(propName) {
            case "capacity":
                return this.capacity;
            case "instructor":
                return this.instructor;
            case "name":
                return this.name;
            case "students":
                return this.students;
            default:
                return super.readPropertyDirectly(propName);
        }
    }

    @Override
    public void writePropertyDirectly(String propName, Object val) {
        if(propName == null) {
            throw new IllegalArgumentException();
        }

        switch (propName) {
            case "capacity":
                this.capacity = (Integer)val;
                break;
            case "instructor":
                this.instructor = (String)val;
                break;
            case "name":
                this.name = (String)val;
                break;
            case "students":
                this.students = val;
                break;
            default:
                super.writePropertyDirectly(propName, val);
        }
    }

    private void writeObject(ObjectOutputStream out) throws IOException {
        writeSerialized(out);
    }

    private void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException {
        readSerialized(in);
    }

    @Override
    protected void writeState(ObjectOutputStream out) throws IOException {
        super.writeState(out);
        out.writeObject(this.capacity);
        out.writeObject(this.instructor);
        out.writeObject(this.name);
        out.writeObject(this.students);
    }

    @Override
    protected void readState(ObjectInputStream in) throws IOException, ClassNotFoundException {
        super.readState(in);
        this.capacity = (Integer)in.readObject();
        this.instructor = (String)in.readObject();
        this.name = (String)in.readObject();
        this.students = in.readObject();
    }

}
